Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h	(revision 1082)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h	(revision 1083)
@@ -435,119 +434,121 @@
       ENDDO
 
-        IF (flag_cdrm(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cdrm",itau_w,cdragm)
-        ENDIF
-
-        IF (flag_cdrh(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cdrh",itau_w,cdragh)
-        ENDIF
-
-        IF (flag_cldl(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cldl",itau_w,cldl)
-        ENDIF
-
-        IF (flag_cldm(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cldm",itau_w,cldm)
-        ENDIF
-
-        IF (flag_cldh(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cldh",itau_w,cldh)
-        ENDIF
-
-        IF (flag_cldt(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cldt", 
+        IF (o_cdrm%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cdrm%name,itau_w,cdragm)
+        ENDIF
+
+        IF (o_cdrh%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cdrh%name,itau_w,cdragh)
+        ENDIF
+
+        IF (o_cldl%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cldl%name,itau_w,cldl)
+        ENDIF
+
+        IF (o_cldm%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cldm%name,itau_w,cldm)
+        ENDIF
+
+        IF (o_cldh%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cldh%name,itau_w,cldh)
+        ENDIF
+
+        IF (o_cldt%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cldt%name, 
      &                   itau_w,cldt*100)
         ENDIF
 
-        IF (flag_cldq(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cldq",itau_w,cldq)
-        ENDIF
-
-        IF (flag_lwp(iff)<=lev_files(iff)) THEN
+        IF (o_cldq%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cldq%name,itau_w,cldq)
+        ENDIF
+
+        IF (o_lwp%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1:klon) = flwp(1:klon)
-      CALL histwrite_phy(nid_files(iff),"lwp",itau_w,zx_tmp_fi2d)
-        ENDIF
-
-        IF (flag_iwp(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_lwp%name,itau_w,zx_tmp_fi2d)
+        ENDIF
+
+        IF (o_iwp%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1:klon) = fiwp(1:klon)
-      CALL histwrite_phy(nid_files(iff),"iwp",itau_w,zx_tmp_fi2d)
-        ENDIF
-
-        IF (flag_ue(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"ue",itau_w,ue)
-        ENDIF
-
-        IF (flag_ve(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"ve",itau_w,ve)
-        ENDIF
-
-        IF (flag_uq(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"uq",itau_w,uq)
-        ENDIF
-
-        IF (flag_vq(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"vq",itau_w,vq)
+      CALL histwrite_phy(nid_files(iff),
+     s                    o_iwp%name,itau_w,zx_tmp_fi2d)
+        ENDIF
+
+        IF (o_ue%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_ue%name,itau_w,ue)
+        ENDIF
+
+        IF (o_ve%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_ve%name,itau_w,ve)
+        ENDIF
+
+        IF (o_uq%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_uq%name,itau_w,uq)
+        ENDIF
+
+        IF (o_vq%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_vq%name,itau_w,vq)
         ENDIF
 
       IF(iflag_con.GE.3) THEN ! sb
-        IF (flag_cape(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cape",itau_w,cape)
-        ENDIF
-
-        IF (flag_pbase(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"pbase",itau_w,pbase)
-        ENDIF
-
-        IF (flag_ptop(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"ptop",itau_w,ema_pct)
-        ENDIF
-
-        IF (flag_fbase(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"fbase",itau_w,ema_cbmf)
-        ENDIF
-
-        IF (flag_prw(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"prw",itau_w,prw)
+        IF (o_cape%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cape%name,itau_w,cape)
+        ENDIF
+
+        IF (o_pbase%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_pbase%name,itau_w,pbase)
+        ENDIF
+
+        IF (o_ptop%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_ptop%name,itau_w,ema_pct)
+        ENDIF
+
+        IF (o_fbase%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_fbase%name,itau_w,ema_cbmf)
+        ENDIF
+
+        IF (o_prw%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_prw%name,itau_w,prw)
         ENDIF
       ENDIF !iflag_con .GE. 3
 
-        IF (flag_s_pblh(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_pblh",itau_w,s_pblh)
-        ENDIF
-
-        IF (flag_s_pblt(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_pblt",itau_w,s_pblt)
-        ENDIF
-
-        IF (flag_s_lcl(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_lcl",itau_w,s_lcl)
-        ENDIF
-
-        IF (flag_s_capCL(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_capCL",itau_w,s_capCL)
-        ENDIF
-
-        IF (flag_s_oliqCL(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_oliqCL",itau_w,s_oliqCL)
-        ENDIF
-
-        IF (flag_s_cteiCL(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_cteiCL",itau_w,s_cteiCL)
-        ENDIF
-
-        IF (flag_s_therm(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_therm",itau_w,s_therm)
-        ENDIF
-
-        IF (flag_s_trmb1(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_trmb1",itau_w,s_trmb1)
-        ENDIF
-
-        IF (flag_s_trmb2(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_trmb2",itau_w,s_trmb2)
-        ENDIF
-
-        IF (flag_s_trmb3(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"s_trmb3",itau_w,s_trmb3)
+        IF (o_s_pblh%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_pblh%name,itau_w,s_pblh)
+        ENDIF
+
+        IF (o_s_pblt%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_pblt%name,itau_w,s_pblt)
+        ENDIF
+
+        IF (o_s_lcl%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_lcl%name,itau_w,s_lcl)
+        ENDIF
+
+        IF (o_s_capCL%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_capCL%name,itau_w,s_capCL)
+        ENDIF
+
+        IF (o_s_oliqCL%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_oliqCL%name,itau_w,s_oliqCL)
+        ENDIF
+
+        IF (o_s_cteiCL%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_cteiCL%name,itau_w,s_cteiCL)
+        ENDIF
+
+        IF (o_s_therm%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_therm%name,itau_w,s_therm)
+        ENDIF
+
+        IF (o_s_trmb1%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_trmb1%name,itau_w,s_trmb1)
+        ENDIF
+
+        IF (o_s_trmb2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_trmb2%name,itau_w,s_trmb2)
+        ENDIF
+
+        IF (o_s_trmb3%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_s_trmb3%name,itau_w,s_trmb3)
         ENDIF
 
@@ -559,4 +560,5 @@
 !      on ecrit u v t q a 850 700 500 200 au niv 3
 
+        ll=0
         DO k=1, nlevSTD
          IF(k.GE.2.AND.k.LE.12) bb2=clevSTD(k)
@@ -566,33 +568,33 @@
 
 ! a refaire correctement !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-       IF (flag_ulevsSTD(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"u"//bb2,
-     & itau_w,uwriteSTD(:,k,iff))
-       ENDIF
-
-       IF (flag_vlevsSTD(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"v"//bb2,  
-     & itau_w,vwriteSTD(:,k,iff))
-       ENDIF
-
-       IF (flag_wlevsSTD(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"w"//bb2,
-     & itau_w,wwriteSTD(:,k,iff))
-       ENDIF
-
-       IF (flag_philevsSTD(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),
-     $                  "phi"//bb2,
+          ll=ll+1
+       IF (o_uSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_uSTDlevs(ll)%name,
+     &                    itau_w,uwriteSTD(:,k,iff))
+       ENDIF
+
+       IF (o_vSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_vSTDlevs(ll)%name,  
+     &                   itau_w,vwriteSTD(:,k,iff))
+       ENDIF
+
+       IF (o_wSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_wSTDlevs(ll)%name,
+     &                    itau_w,wwriteSTD(:,k,iff))
+       ENDIF
+
+       IF (o_phiSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_phiSTDlevs(ll)%name,
      &               itau_w,phiwriteSTD(:,k,iff))
        ENDIF
 
-       IF (flag_qlevsSTD(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"q"//bb2,
-     & itau_w, qwriteSTD(:,k,iff))
-       ENDIF
-
-       IF (flag_tlevsSTD(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"t"//bb2,
-     & itau_w, twriteSTD(:,k,iff))
+       IF (o_qSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_qSTDlevs(ll)%name,
+     &                   itau_w, qwriteSTD(:,k,iff))
+       ENDIF
+
+       IF (o_tSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_tSTDlevs(ll)%name,
+     &                   itau_w, twriteSTD(:,k,iff))
        ENDIF
 
@@ -600,5 +602,5 @@
        ENDDO
 
-      IF (flag_t_oce_sic(iff)<=lev_files(iff)) THEN
+      IF (o_t_oce_sic%flag(iff)<=lev_files(iff)) THEN
       DO i=1, klon
        IF (pctsrf(i,is_oce).GT.epsfra.OR.
@@ -611,5 +613,6 @@
        ENDIF
       ENDDO
-      CALL histwrite_phy(nid_files(iff),"t_oce_sic",itau_w,zx_tmp_fi2d)
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_t_oce_sic%name,itau_w,zx_tmp_fi2d)
       ENDIF
 
@@ -618,231 +621,241 @@
       IF (iflag_con.GE.3) THEN
       IF (iflag_coupl.EQ.1) THEN
-       IF (flag_ale_bl(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"ale_bl",itau_w,ale_bl)
-       ENDIF
-       IF (flag_alp_bl(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"alp_bl",itau_w,alp_bl)
+       IF (o_ale_bl%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_ale_bl%name,itau_w,ale_bl)
+       ENDIF
+       IF (o_alp_bl%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_alp_bl%name,itau_w,alp_bl)
        ENDIF
       ENDIF !iflag_coupl.EQ.1
-
+      ENDIF !(iflag_con.GE.3)
+      IF (iflag_con.EQ.3) THEN
       IF (iflag_wake.EQ.1) THEN
-       IF (flag_ale_wk(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"ale_wk",itau_w,ale_wake)
-       ENDIF
-       IF (flag_alp_wk(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"alp_wk",itau_w,alp_wake)
-       ENDIF
-
-       IF (flag_ale(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"ale",itau_w,ale)
-       ENDIF
-       IF (flag_alp(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"alp",itau_w,alp)
-       ENDIF
-       IF (flag_cin(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"cin",itau_w,cin)
-       ENDIF
-       IF (flag_wape(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"WAPE",itau_w,wake_pe)
-       ENDIF
-       IF (flag_wake_h(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"wake_h",itau_w,wake_h)
-       ENDIF
-
-       IF (flag_wake_s(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"wake_s",itau_w,wake_s)
-       ENDIF
-
-        IF (flag_wake_deltat(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"wake_deltat",
+       IF (o_ale_wk%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_ale_wk%name,itau_w,ale_wake)
+       ENDIF
+       IF (o_alp_wk%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_alp_wk%name,itau_w,alp_wake)
+       ENDIF
+
+       IF (o_ale%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_ale%name,itau_w,ale)
+       ENDIF
+       IF (o_alp%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_alp%name,itau_w,alp)
+       ENDIF
+       IF (o_cin%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_cin%name,itau_w,cin)
+       ENDIF
+       IF (o_wape%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_WAPE%name,itau_w,wake_pe)
+       ENDIF
+       IF (o_wake_h%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_wake_h%name,itau_w,wake_h)
+       ENDIF
+
+       IF (o_wake_s%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_wake_s%name,itau_w,wake_s)
+       ENDIF
+
+        IF (o_wake_deltat%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_wake_deltat%name,
      $                     itau_w,wake_deltat)
         ENDIF
 
-        IF (flag_wake_deltaq(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"wake_deltaq",
+        IF (o_wake_deltaq%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_wake_deltaq%name,
      $                    itau_w,wake_deltaq)
         ENDIF
 
-        IF (flag_wake_omg(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"wake_omg",itau_w,wake_omg)
-        ENDIF
-      ENDIF
-
-        IF (flag_Vprecip(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"Vprecip",itau_w,Vprecip)
-        ENDIF
-
-        IF (flag_ftd(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"ftd",itau_w,ftd)
-        ENDIF
-
-        IF (flag_fqd(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"fqd",itau_w,fqd)
-        ENDIF
-
-      ENDIF !(iflag_con.GE.3) 
+        IF (o_wake_omg%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),
+     s                    o_wake_omg%name,itau_w,wake_omg)
+        ENDIF
+      ENDIF
+
+        IF (o_Vprecip%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_Vprecip%name,itau_w,Vprecip)
+        ENDIF
+
+        IF (o_ftd%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_ftd%name,itau_w,ftd)
+        ENDIF
+
+        IF (o_fqd%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_fqd%name,itau_w,fqd)
+        ENDIF
+
+      ENDIF !(iflag_con.EQ.3) 
  
       ELSE IF (type_ocean=='slab  ') THEN
 
-      IF ( flag_slab_bils(iff)<=lev_files(iff)) 
+      IF ( o_slab_bils%flag(iff)<=lev_files(iff)) 
      $     CALL histwrite_phy(
-     $     nid_files(iff),"slab_wbils_oce",itau_w,slab_wfbils)
+     $     nid_files(iff),o_slab_bils%name,itau_w,slab_wfbils)
 
       ENDIF !type_ocean == force/slab
 
-      IF (flag_weakinv(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"weakinv",itau_w,weak_inversion)
-      ENDIF
-
-      IF (flag_dthmin(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dthmin",itau_w,dthmin)
-      ENDIF
-
-       IF (flag_cldtau(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"cldtau",itau_w,cldtau)
-       ENDIF
-
-       IF (flag_cldemi(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"cldemi",itau_w,cldemi)
-       ENDIF
-
-!      IF (flag_pr_con_l(iff)<=lev_files(iff)) THEN
-!      CALL histwrite_phy(nid_files(iff),"pmflxr",itau_w,pmflxr)
+      IF (o_weakinv%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                  o_weakinv%name,itau_w,weak_inversion)
+      ENDIF
+
+      IF (o_dthmin%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dthmin%name,itau_w,dthmin)
+      ENDIF
+
+       IF (o_cldtau%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_cldtau%name,itau_w,cldtau)
+       ENDIF
+
+       IF (o_cldemi%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_cldemi%name,itau_w,cldemi)
+       ENDIF
+
+!      IF (o_pr_con_l%flag(iff)<=lev_files(iff)) THEN
+!      CALL histwrite_phy(nid_files(iff),o_pmflxr%name,itau_w,pmflxr)
 !      ENDIF
 
-!      IF (flag_pr_con_i(iff)<=lev_files(iff)) THEN
-!      CALL histwrite_phy(nid_files(iff),"pmflxs",itau_w,pmflxs)
+!      IF (o_pr_con_i%flag(iff)<=lev_files(iff)) THEN
+!      CALL histwrite_phy(nid_files(iff),o_pmflxs%name,itau_w,pmflxs)
 !      ENDIF
 
-!      IF (flag_pr_lsc_l(iff)<=lev_files(iff)) THEN
-!      CALL histwrite_phy(nid_files(iff),"prfl",itau_w,prfl)
+!      IF (o_pr_lsc_l%flag(iff)<=lev_files(iff)) THEN
+!      CALL histwrite_phy(nid_files(iff),o_prfl%name,itau_w,prfl)
 !      ENDIF
 
-!      IF (flag_pr_lsc_i(iff)<=lev_files(iff)) THEN
-!      CALL histwrite_phy(nid_files(iff),"psfl",itau_w,psfl)
+!      IF (o_pr_lsc_i%flag(iff)<=lev_files(iff)) THEN
+!      CALL histwrite_phy(nid_files(iff),o_psfl%name,itau_w,psfl)
 !      ENDIF
 
-      IF (flag_rh2m(iff)<=lev_files(iff)) THEN
+      IF (o_rh2m%flag(iff)<=lev_files(iff)) THEN
       DO i=1, klon
        zx_tmp_fi2d(i)=MIN(100.,rh2m(i)*100.)
       ENDDO
-      CALL histwrite_phy(nid_files(iff),"rh2m",itau_w,zx_tmp_fi2d)
-      ENDIF
-
-      IF (flag_qsat2m(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"qsat2m",itau_w,qsat2m)
-      ENDIF
-
-      IF (flag_tpot(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"tpot",itau_w,tpot)
-      ENDIF
-
-       IF (flag_tpote(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"tpote",itau_w,tpote)
-       ENDIF
-
-      IF (flag_SWnetOR(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_rh2m%name,itau_w,zx_tmp_fi2d)
+      ENDIF
+
+      IF (o_qsat2m%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_qsat2m%name,itau_w,qsat2m)
+      ENDIF
+
+      IF (o_tpot%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_tpot%name,itau_w,tpot)
+      ENDIF
+
+       IF (o_tpote%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_tpote%name,itau_w,tpote)
+       ENDIF
+
+      IF (o_SWnetOR%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = fsolsw( 1 : klon, is_ter)
-      CALL histwrite_phy(nid_files(iff),"SWnetOR",itau_w, zx_tmp_fi2d)
-      ENDIF
-
-      IF (flag_SWdownOR(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_SWnetOR%name,itau_w, zx_tmp_fi2d)
+      ENDIF
+
+      IF (o_SWdownOR%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1:klon) = solsw(1:klon)/(1.-albsol1(1:klon))
-      CALL histwrite_phy(nid_files(iff),"SWdownOR",itau_w, zx_tmp_fi2d)
-      ENDIF
-
-      IF (flag_LWdownOR(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"LWdownOR",itau_w,sollwdown)
-      ENDIF
-
-      IF (flag_snowl(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"snowl",itau_w,snow_lsc)
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_SWdownOR%name,itau_w, zx_tmp_fi2d)
+      ENDIF
+
+      IF (o_LWdownOR%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                  o_LWdownOR%name,itau_w,sollwdown)
+      ENDIF
+
+      IF (o_snowl%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_snowl%name,itau_w,snow_lsc)
       ENDIF
 
       IF (iflag_con.GE.3) THEN
-      IF (flag_cape_max(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"cape_max",itau_w,cape)
+      IF (o_cape_max%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_cape_max%name,itau_w,cape)
       ENDIF
       ENDIF !(iflag_con.GE.3)
 
-      IF (flag_solldown(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"solldown",itau_w,sollwdown)
-      ENDIF
-
-      IF (flag_dtsvdfo(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dtsvdfo",itau_w,d_ts(:,is_oce))
-      ENDIF
-
-      IF (flag_dtsvdft(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dtsvdft",itau_w,d_ts(:,is_ter))
-      ENDIF
-
-       IF (flag_dtsvdfg(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),
-     $                     "dtsvdfg",itau_w, d_ts(:,is_lic))
-       ENDIF
-
-       IF (flag_dtsvdfi(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dtsvdfi",itau_w,d_ts(:,is_sic))
-       ENDIF
-
-       IF (flag_rugs(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"rugs",itau_w,zxrugs)
+      IF (o_solldown%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_solldown%name,itau_w,sollwdown)
+      ENDIF
+
+      IF (o_dtsvdfo%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                 o_dtsvdfo%name,itau_w,d_ts(:,is_oce))
+      ENDIF
+
+      IF (o_dtsvdft%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_dtsvdft%name,itau_w,d_ts(:,is_ter))
+      ENDIF
+
+       IF (o_dtsvdfg%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),
+     $                   o_dtsvdfg%name,itau_w, d_ts(:,is_lic))
+       ENDIF
+
+       IF (o_dtsvdfi%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_dtsvdfi%name,itau_w,d_ts(:,is_sic))
+       ENDIF
+
+       IF (o_rugs%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_rugs%name,itau_w,zxrugs)
        ENDIF
 
 ! Champs 3D:
-       IF (flag_lwcon(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"lwcon",itau_w,flwc)
-       ENDIF
-
-       IF (flag_iwcon(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"iwcon",itau_w,fiwc)
-       ENDIF
-
-       IF (flag_temp(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"temp",itau_w,t_seri)
-       ENDIF
-
-       IF (flag_theta(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"theta",itau_w,theta)
-       ENDIF
-
-       IF (flag_ovap(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"ovap",itau_w,qx(:,:,ivap))
-       ENDIF
-
-       IF (flag_geop(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"geop",itau_w,zphi)
-       ENDIF
-
-       IF (flag_vitu(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"vitu",itau_w,u_seri)
-       ENDIF
-
-       IF (flag_vitv(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"vitv",itau_w,v_seri)
-       ENDIF
-
-       IF (flag_vitw(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"vitw",itau_w,omega)
-       ENDIF
-
-        IF (flag_pres(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"pres",itau_w,pplay)
-        ENDIF
-
-       IF (flag_rneb(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"rneb",itau_w,cldfra)
-       ENDIF
-
-       IF (flag_rnebcon(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"rnebcon",itau_w,rnebcon)
-       ENDIF
-
-       IF (flag_rhum(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"rhum",itau_w,zx_rh)
-       ENDIF
-
-      IF (flag_ozone(iff)<=lev_files(iff)) THEN
+       IF (o_lwcon%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_lwcon%name,itau_w,flwc)
+       ENDIF
+
+       IF (o_iwcon%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_iwcon%name,itau_w,fiwc)
+       ENDIF
+
+       IF (o_temp%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_temp%name,itau_w,t_seri)
+       ENDIF
+
+       IF (o_theta%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_theta%name,itau_w,theta)
+       ENDIF
+
+       IF (o_ovap%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_ovap%name,itau_w,qx(:,:,ivap))
+       ENDIF
+
+       IF (o_geop%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_geop%name,itau_w,zphi)
+       ENDIF
+
+       IF (o_vitu%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_vitu%name,itau_w,u_seri)
+       ENDIF
+
+       IF (o_vitv%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_vitv%name,itau_w,v_seri)
+       ENDIF
+
+       IF (o_vitw%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_vitw%name,itau_w,omega)
+       ENDIF
+
+        IF (o_pres%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_pres%name,itau_w,pplay)
+        ENDIF
+
+       IF (o_rneb%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_rneb%name,itau_w,cldfra)
+       ENDIF
+
+       IF (o_rnebcon%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_rnebcon%name,itau_w,rnebcon)
+       ENDIF
+
+       IF (o_rhum%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_rhum%name,itau_w,zx_rh)
+       ENDIF
+
+      IF (o_ozone%flag(iff)<=lev_files(iff)) THEN
       DO k=1, klev
        DO i=1, klon
@@ -852,47 +865,51 @@
        ENDDO !i
       ENDDO !k
-      CALL histwrite_phy(nid_files(iff),"ozone",itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),o_ozone%name,itau_w,zx_tmp_fi3d)
       ENDIF
 
       IF(iflag_con.GE.3) THEN
-       IF (flag_upwd(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"upwd",itau_w,upwd)
+       IF (o_upwd%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_upwd%name,itau_w,upwd)
        ENDIF
       ENDIF !(iflag_con.GE.3)
 
-       IF (flag_dtphy(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dtphy",itau_w,d_t)
-       ENDIF
-
-       IF (flag_dqphy(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dqphy",itau_w, d_qx(:,:,ivap))
+       IF (o_dtphy%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtphy%name,itau_w,d_t)
+       ENDIF
+
+       IF (o_dqphy%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                  o_dqphy%name,itau_w, d_qx(:,:,ivap))
        ENDIF
 
         DO nsrf=1, nbsrf
-        IF (flag_albe_sol(iff)<=lev_files(iff)) THEN 
+        IF (o_albe_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN 
         zx_tmp_fi2d(1 : klon) = falb1( 1 : klon, nsrf)
-        CALL histwrite_phy(nid_files(iff),"albe_"//clnsurf(nsrf),itau_w,
+        CALL histwrite_phy(nid_files(iff),
+     s                    o_albe_srf(nsrf)%name,itau_w,
+     $                     zx_tmp_fi2d)
+        ENDIF
+
+        IF (o_rugs_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN  
+        zx_tmp_fi2d(1 : klon) = frugs( 1 : klon, nsrf)
+        CALL histwrite_phy(nid_files(iff),
+     s                     o_rugs_srf(nsrf)%name,itau_w,
      $      zx_tmp_fi2d)
         ENDIF
 
-        IF (flag_rugs_sol(iff)<=lev_files(iff)) THEN  
-        zx_tmp_fi2d(1 : klon) = frugs( 1 : klon, nsrf)
-        CALL histwrite_phy(nid_files(iff),"rugs_"//clnsurf(nsrf),itau_w,
-     $      zx_tmp_fi2d)
-        ENDIF
-
-        IF (flag_ages_sol(iff)<=lev_files(iff)) THEN
+        IF (o_ages_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d(1 : klon) = agesno( 1 : klon, nsrf)
-        CALL histwrite_phy(nid_files(iff),"ages_"//clnsurf(nsrf),itau_w
+        CALL histwrite_phy(nid_files(iff),
+     s                     o_ages_srf(nsrf)%name,itau_w
      $    ,zx_tmp_fi2d)
         ENDIF
         ENDDO !nsrf=1, nbsrf
 
-       IF (flag_albs(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"albs",itau_w,albsol1)
-       ENDIF
-
-       IF (flag_albslw(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"albslw",itau_w,albsol2)
+       IF (o_albs%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_albs%name,itau_w,albsol1)
+       ENDIF
+
+       IF (o_albslw%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_albslw%name,itau_w,albsol2)
        ENDIF
 
